"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handle = void 0;
const functions = __importStar(require("firebase-functions"));
const admin = __importStar(require("firebase-admin"));
const mail_1 = __importDefault(require("@sendgrid/mail"));
admin.initializeApp();
function handle(params) {
    return functions.https.onCall(async (req) => {
        const { body, subject, replyBody, replyTo, replySubject, attachments } = req.data;
        if (!body) {
            throw new functions.https.HttpsError("invalid-argument", "missing email/name/body");
        }
        mail_1.default.setApiKey(params.apiKey);
        try {
            await mail_1.default.send({
                from: params.emailFrom,
                to: params.emailTo,
                subject: subject || params.defaultSubject || "",
                text: body,
                attachments: attachments
            });
            if (params.reply && replyBody && replyTo) {
                await mail_1.default.send({
                    from: params.emailFrom,
                    to: replyTo,
                    subject: replySubject || params.reply.defaultSubject || "",
                    text: replyBody
                });
            }
        }
        catch (e) {
            throw new functions.https.HttpsError("failed-precondition", e);
        }
    });
}
exports.handle = handle;
